#
# spec file for package ntl
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           ntl
%define lname	libntl15
Version:        9.2.0
Release:        3.2
Summary:        Library for Number Theory
License:        GPL-2.0+
Group:          Productivity/Scientific/Math
Url:            http://shoup.net/ntl/

Source:         http://shoup.net/ntl/ntl-%version.tar.gz
Patch1:         ntl-automake.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  gcc-c++
BuildRequires:  gf2x-devel
BuildRequires:  gmp-devel >= 3.1
BuildRequires:  libtool

%description
NTL is a high-performance, portable C++ library providing data
structures and algorithms for manipulating signed, arbitrary length
integers, and for vectors, matrices, and polynomials over the
integers and over finite fields.

%package -n %lname
Summary:        Library for Number Theory
Group:          System/Libraries

%description -n %lname
NTL is a high-performance, portable C++ library providing data
structures and algorithms for manipulating signed, arbitrary length
integers, and for vectors, matrices, and polynomials over the
integers and over finite fields.

%package devel
Summary:        Development files for libntl
Group:          Development/Libraries/C and C++
Requires:       %lname = %version

%description devel
NTL is a high-performance, portable C++ library providing data
structures and algorithms for manipulating signed, arbitrary length
integers, and for vectors, matrices, and polynomials over the
integers and over finite fields.

This package contains the headers and library links to libntl.

%prep
%setup -qn ntl-%version
%patch -P 1 -p1
pushd src/;
for i in *.c; do
	mv "$i" "${i%.c}.cpp";
done;
rm -f makefile;
popd;

%build
mkdir -p m4;
autoreconf -fi;
%configure --disable-static
make %{?_smp_mflags}
# Ensure we have all source files in Makefile.am
if ldd -r src/.libs/libntl.so | grep undefined; then
	exit 1
fi

%install
%make_install
rm -f "%buildroot/%_libdir"/*.la

%post   -n %lname -p /sbin/ldconfig
%postun -n %lname -p /sbin/ldconfig

%files -n %lname
%defattr(-,root,root)
%_libdir/libntl.so.15*

%files devel
%defattr(-,root,root)
%_includedir/NTL
%_libdir/libntl.so
%doc doc/*

%changelog
* Wed Jun 24 2015 jengelh@inai.de
- Update to new upstream release 9.2.0
  * Performance improvements to zz_pX and Vec<zz_p>.
  * Performance improvements to ZZX: implemented asymptotically fast
  CRT code for HomMul and more cache-friendly logic.
  * Completed the transition away from floating-point arithmetic for
  the implementation of single-precision modular arithmetic.
* Fri Mar 27 2015 jengelh@inai.de
- Update to new upstream release 9.0.0
  * The interface to the single-precision modular arithmetic
  routines has been modified slightly: In particular, on 64-bit
  x86/GCC platforms, single precision moduli can now be up to 60
  bits, rather than 50 bits. Using larger moduli speeds up a number
  of things, like ZZ_pX arithmetic, as fewer primes need to be used
  in Chinese Remaindering steps.
* Thu Feb 12 2015 jengelh@inai.de
- Update ntl-automake.diff: add a missing backslash causing not all
  headers to be installed. Support mingw a bit better, too.
  Support non-C++11 systems.
* Tue Feb  3 2015 jengelh@inai.de
- Update to new upstream release 8.1.2
  * Added support for "user defined" FFT primes for zz_p.
  * Added explicit constructors corresponding to promotions.
  * Thread safety, requires C++11 concurrency.
* Fri Apr 18 2014 jengelh@inai.de
- Update to new upstream release 6.1.0
  * Replaced the old template-like macros for vectors, matrices, and
  pairs with true template classes: Vec<T>, Mat<T>, and Pair<S,T>.
  * There are many new conversions provided.
  * Improve speed for single-precision FFT
  * Added support for "user defined" FFT primes for <tt>zz_p</tt>.
* Sun Dec  9 2012 jengelh@inai.de
- Ensure that only NTL_ defined appear in NTL/config.h
- Set RPM group according to rpmlint
* Thu Sep 15 2011 jengelh@medozas.de
- Initial package (version 5.5.2) for build.opensuse.org
